<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text"/>

<!--
  This is an example xsl template for the SableCC's parser generated xml.
  This file generates a MyDepthFirstAdapter that should be identical to
  DepthFirstAdapter.
-->

<xsl:template match="parser">
package <xsl:value-of select="@package"/>.analysis;

import java.util.*;
import <xsl:value-of select="@package"/>.node.*;

public class MyDepthFirstAdapter extends AnalysisAdapter
{
    public void inStart(Start node)
    {
        defaultIn(node);
    }

    public void outStart(Start node)
    {
        defaultOut(node);
    }

    public void defaultIn(Node node)
    {
    }

    public void defaultOut(Node node)
    {
    }

    public void caseStart(Start node)
    {
        inStart(node);
        node.get<xsl:value-of select="productions/production/@ename"/>().apply(this);
        node.getEOF().apply(this);
        outStart(node);
    }

<xsl:for-each select="productions/production/alt">
    void case<xsl:value-of select="@ename"/> (<xsl:value-of select="@ename"/> node)
    {
      in<xsl:value-of select="@ename"/> (node);
<xsl:for-each select="elem">
<xsl:if test="not(@is_list)">
      if ( node.get<xsl:value-of select="@ename"/>() != null )
      {
          node.get<xsl:value-of select="@ename"/>().apply(this);
      }
</xsl:if>
<xsl:if test="@is_list">
      {
          Object temp[] = node.get<xsl:value-of select="@ename"/>().toArray();
          for(int i = 0; i &lt; temp.length; i++)
          {
              ((<xsl:value-of select="@etype"/>) temp[i]).apply(this);
          }
      }
</xsl:if>
</xsl:for-each>
      out<xsl:value-of select="@ename"/> (node);
    }

    void in<xsl:value-of select="@ename"/> (<xsl:value-of select="@ename"/> node)
    {
      defaultIn(node);
    }

    void out<xsl:value-of select="@ename"/> (<xsl:value-of select="@ename"/> node)
    {
      defaultOut(node);
    }
</xsl:for-each> <!-- productions/production/alt -->
}
</xsl:template>

</xsl:stylesheet>

